# CPSC501W25A3
## Devon Harstrom, 30132397

## Description
This program reflection inspection of an object's class, including information such as its immediate superclass, interfaces, constructors, methods, and fields. 
It uses Java's reflection API, Then prints the details about each component of the class (into 8 text files when driver is ran), 
other information is modifiers (public, private, static, etc.), method parameters, field values, and exceptions thrown by constructors or methods.
The code is recursive, So it will explore things such as interfaces, superclasses or object references.

## How to Run:
First add this to VM options in config: 
```
--add-opens java.base/java.lang=ALL-UNNAMED
--add-opens java.base/java.util=ALL-UNNAMED
```

run driver.java in src, and it will output 8 txt files, in these files are the entire reflection.
```
javac Driver.java
java Driver
```
Output files are:
```
script<n>.txt //where <n> is a number from 1-8
```

## Refactoring
Made a series of refactorings such as extract method, field/variable name changing, conditional, decompose, general code cleaning like adjusting for loops, etc. Read about them in detail in git commits (working branch)

## Testing
The tests are relatively simple calling different methods from inspector such as getInterface, etc.
The tests use different fake/mock classes to test the output excepting the string/words in the output.txt which is captured in the test

## Badges
![Test Status](https://img.shields.io/badge/tests-passing-brightgreen)

## Visuals
![Description of image](outputSnippet.PNG)




## Assignment Requirements:
This method will introspect on the object specified by the first parameter obj, printing what it
finds to standard output. You should find the following information about the object:
1. ~~The name of the declaring class - DONE~~
2. ~~The name of the immediate super-class - DONE
   a. Always explore super-class immediately and recursively (even if recursive=false)~~
3. ~~The name of each interface the class implements - DONE
   a. Always explore interfaces immediately and recursively (even if recursive=false)~~
4. ~~The constructors the class declares. For each, also find the following: <br>~~
   ~~a. The name <br>~~
   ~~b. The exceptions thrown <br>~~
   ~~c. The parameter types <br>~~
   ~~d. The modifiers <br>~~
5. ~~The methods the class declares. For each, also find the following: <br>
   a. The name <br>
   b. The exceptions thrown <br>
   c. The parameter types <br>
   d. The return-type <br>
   e. The modifiers <br>~~
6. ~~The fields the class declares. For each, also find the following: <br>
   a. The name </br>
   b. The type <br>
   c. The modifiers <br>
   d. The current value <br>
   1. If the field is an object reference, and recursive is set to false, then simply print out the
      “reference value” directly (this will be the name of the object’s class plus the object’s “identity hash code” ex. java.lang.Object@7d4991ad). <br>
   2. If the field is an object reference, and recursive is set to true, then
      immediately recurse on the object.~~

---

Recursive Inspection (recursive = true)
Recursive introspection is an optional method argument that can be enabled for fields
introspection.
1. If the inspect method is invoked with recursive set to false, then simply find information
   for the object specified.
2. If it is true, then immediately recursively inspect each field/array object in the same
   manner of the original object.
   Other Requirements<br> <br>
1. You should have descriptive output. For example, you should not use the toString() for
   Field/Method or Class to get info. You will need to use the provided API methods to pull
   out the information in the Field/Method/Class/etc. and print more descriptive
   explanatory lines.
2. When printing modifiers you must convert the returned integer information into
   descriptive information such as public/private/final/static/transient/etc. for the
   modifiers.
3. For your submission a Driver program will be provided that creates objects to inspect,
   and then invokes your inspect method. This driver will output eight different
   script<no>.txt files, one for each object.
4. During the marking process, the TA will compile and run your code to verify that
   everything works.
5. You must also use version control, unit testing, and refactoring throughout this
   assignment. Report some of your refactorings in the project’s readme.md. This usage
   doesn’t have to be robust but is designed to encourage continual usage of versioncontrolled programming development.